/**************************************************************************
 * 
 * PROJECT: Task Control Management (TCM)
 *
 * FILE: CSFsmResponder.h
 *
 * ABSTRACT: Object for responding using CSFsmResponseModuleClass.
 *
 * EXPORTS:
 *
 * $Revision: 1.2 $
 * $Date: 1998/03/18 14:41:47 $
 * $Author: reids $
 *
 * REVISION HISTORY:
 *
 * $Log: CSFsmResponder.h,v $
 * Revision 1.2  1998/03/18 14:41:47  reids
 * Changes to support both SunOS and Solaris versions.
 *
 * Revision 1.1  97/11/21  14:04:58  reids
 * First release of TCM -- seems to be a stable version
 * 
 *
 **************************************************************************/

#ifndef INCCSFsmResponder
#define INCCSFsmResponder

typedef class CSFsmResponseModuleClass *CSFsmResponseModule;
/*#include "CSFsmResponseModule.pkg.h"*/

#define NO_STIM_MODULE "Stimulus Not Handled"

typedef class CSFsmResponderClass *CSFsmResponder;

class CSFsmResponderClass {
 public:
  CSFsmResponderClass() { _next = NULL; _stimulus = NULL; };
  CSFsmResponderClass(String stimulus) : _stimulus(stimulus) { _next = NULL; };

  CSFsmResponder getNext(void) const { return _next; }
  void setNext(CSFsmResponder next) { _next = next; }

  virtual boolean respond (String context, int response) const = 0;
  virtual boolean missingStimulus (String stimulus) const = 0;

  void add (CSFsm fsm);

 private:
  CSFsmResponder _next;

 protected:
  String _stimulus;

  void setMissingStimulusResponse (CSFsm fsm, String stimulus);

  // static CSFsmResponseModule _noStimResponse = NULL;
};

#endif // INCCSFsmResponder
