/*****************************************************************************
 *
 * PROJECT: Task Control Management.
 *
 * (c) Copyright 1996 Reid Simmons.  All rights reserved.
 *
 * FILE: basics.cc
 *
 * ABSTRACT: Basic definitions needed by TCM
 *
 * $Source: /afs/cs/project/TCA/Master/tcaV8/tcm/src/tcmBasics.cc,v $ 
 * $Revision: 1.3 $
 * $Date: 1998/06/02 10:39:42 $
 * $Author: reids $
 *
 * REVISION HISTORY:
 *
 * $Log: tcmBasics.cc,v $
 * Revision 1.3  1998/06/02 10:39:42  reids
 * Increased overall efficiency of TCM.
 *
// Revision 1.2  97/12/04  17:50:23  reids
// Another fairly stable version (except that monitors do not quite work)
// 
// Revision 1.1  97/11/21  14:06:41  reids
// First release of TCM -- seems to be a stable version
// 
 *
 *****************************************************************************/

#include "tcmBasics.h"

#ifndef macintosh
#include <sys/timeb.h>
#else
#include <stdlib.h>
#include <time.h>
#endif

#ifndef macintosh
MSecs timeInMsecs (void)
{
  struct timeval timeBlock;
  
  gettimeofday(&timeBlock, NULL);
  return (1000*timeBlock.tv_sec + timeBlock.tv_usec/1000);
}
#else
unsigned long timeInMsecs (void)
{
  return (clock()*1000)/CLOCKS_PER_SEC;
}

char *strdup(const char *str)
{
  char *newString = new char[strlen(str)+1];
  strcpy(newString, str);
  return newString;
}
#endif
