/**Alert-DBA: Eventually extend to deal with command-line arguments. */

public class Parameters extends Object
{
	/* Class Constants */
	/* Note:  Environment is not available as of JDK1.1.1... *SIGH* */
  public final static String DEFAULT_VDT_HOME  = ".";
  public final static String PLAN_SUBDIRECTORY = "PLANS";

	/* Class Variables */
  protected static Parameters parameters = null;

	/* Class Methods */
  public static void setParameters ( String args[] )
  {
    parameters = new Parameters ( args );
  }

  public static Parameters getParameters()  { return Parameters.parameters; }



	/* Instance Variables */
  String  vdtPlansDirectory;


	/* Instance Methods */
  public Parameters ( String args[] )
  {
    if ( args.length > 0 )
      vdtPlansDirectory = args[0];
    else
      vdtPlansDirectory = Parameters.DEFAULT_VDT_HOME
	+ Parameters.getFilepathSeparator() + Parameters.PLAN_SUBDIRECTORY;
  }


  public static String getFilepathSeparator ( )
  {
    return System.getProperty ( "file.separator", "/" );
  }


  public String getPlanDirectory ( )
  {
    String  appendToBaseDir;

    if (   ( vdtPlansDirectory . endsWith ( getFilepathSeparator() ) )
	|| ( vdtPlansDirectory . length() == 0                       ) )
      appendToBaseDir = "";
    else
      appendToBaseDir = getFilepathSeparator();

    return vdtPlansDirectory + appendToBaseDir;
  }

  public String getPlanPath ( String thePlanName )
  {
    return getPlanDirectory() + thePlanName;
  }


  public static void main ( String args[] )
  {
    Parameters.setParameters ( args );
    System.err.println ( "test:  "
			 + Parameters.getParameters().getPlanPath ( "test" ) );
  }
}
