
#include "_TDL_IterationIndex.H"

/*static*/ ostream &
_TDL_IterationIndex::printIndexList (
				 ostream          & theOstream,
				 const _TDL_Dlist & theListOfIterationIndexes,
				 _TDL_Dnode       * theLastNodeToPrint,
						      /*= (_TDL_Dnode *) NULL*/
				 _TDL_Dnode       * theFirstNodeToPrint       )
{						      /*= (_TDL_Dnode *) NULL*/
  _TDL_Dnode * node;

  theOstream << "[ ";

  for ( node  = theListOfIterationIndexes . getFirstNode();
	node != (_TDL_Dnode *) NULL;
	node  = node -> getNextNode()
       )
  {
    if ( theFirstNodeToPrint == node )
      theFirstNodeToPrint = (_TDL_Dnode *) NULL;

    if ( theFirstNodeToPrint == (_TDL_Dnode *) NULL )
      theOstream << ((_TDL_IterationIndex *) node) -> getCurrentIndex() << " ";

    if ( theLastNodeToPrint == node )
      break;
  }

  theOstream << " ]";
  return theOstream;
}



/*virtual*/
_TDL_IterationIndex::~_TDL_IterationIndex()
{
  currentIndex        = _TDL_IterationIndex::INVALID_INDEX;
  ignoreNextIncrement = TRUE;
}

void
_TDL_IterationIndex::incrementIndex()
{
  if ( getIgnoreNextIncrement() == TRUE )
  {
    setIgnoreNextIncrement ( FALSE );
  }
  else
  {
    setCurrentIndex ( getCurrentIndex() + 1 );
  }
}


	/* iostreamBase interface */
/*virtual*/ ostream &
_TDL_IterationIndex::printObject ( ostream    & theOstream,
				   const char * theIndentString /*=""*/ ) const
{
  theOstream << theIndentString << "IterationIndex:  " << getCurrentIndex()
	     << "  " << ( (getIgnoreNextIncrement() == TRUE)
			 ? "[IgnoringNextIncrement]"
			 : "[NextIncrementWillHappen]" )
	     << endl;

  return theOstream;
}


	/* These operations are disabled (prohibited) & unimplemented */
/*private*/
_TDL_IterationIndex::_TDL_IterationIndex (
				  const _TDL_IterationIndex & theObjectToCopy )
  : _TDL_Dnode          (                                          ),
    currentIndex        ( theObjectToCopy.getCurrentIndex()        ),
    ignoreNextIncrement ( theObjectToCopy.getIgnoreNextIncrement() )
{
  TDL::getLogStream()
    << "_TDL_IterationIndex copy constructor bug." << endl;
}

/*private*/ _TDL_IterationIndex &
_TDL_IterationIndex::operator = ( const _TDL_IterationIndex & theObjectToCopy )
{
  setCurrentIndex        ( theObjectToCopy.getCurrentIndex()        );
  setIgnoreNextIncrement ( theObjectToCopy.getIgnoreNextIncrement() );
  setPreviousNode        ( (_TDL_Dnode *) NULL                      );
  setNextNode            ( (_TDL_Dnode *) NULL                      );
  TDL::getLogStream()
    << "_TDL_IterationIndex operator = bug." << endl;
  return *this;
}

